#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <ctype.h>


/*
filename server_ipaddres portno

argv[0] filename
argv[1] server_ipaddress
argv[2] portno

*/

void error(const char *msg)
{
    perror(msg);
    exit(0);
}

int main(int argc, char *argv[])
{

    int sockfd, portno, n;
    struct sockaddr_in serv_addr;
    struct hostent *server; //store information about given host
    
    char buffer[255];
    /* if there are not 3 arguments 
    Wheather user has not provided 
    - host name
    - IP adress 
    - Port number
    */
    if (argc < 3){ 
        fprintf(stderr, "usage %s No hostname port\n", argv[0]);
        exit(1);
    }

    portno = atoi(argv[2]);
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd < 0) {
        error("Error opening socket"); 
    }
    server = gethostbyname(argv[1]);
    if(server == NULL)
    {
        fprintf(stderr , "Error , no such host ");
    }
    bzero((char *) &serv_addr , sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    bcopy((char *) server->h_addr , (char *) &serv_addr.sin_addr.s_addr , server->h_length);
    serv_addr.sin_port = htons(portno);
    if(connect(sockfd , (struct sockaddr *) &serv_addr , sizeof(serv_addr))<0)
        error("Connection Failed");
    else 
        fprintf(stderr, "Client is now connected to server\n");
    
    while(1) {
        
        bzero(buffer , 255);
        fgets(buffer , 255 , stdin);
        //printf("cmd: %s\n", buffer);
        n = write(sockfd , buffer , strlen(buffer));
        
        if(n < 0)
            error("Error on writing");
        bzero(buffer , 255);
        n = read(sockfd , buffer , 255);
        if(n < 0)
            error("Error on reading.");
        printf("Server> %s", buffer);
            
        int i = strncmp("Bye" , buffer , 3);
        if (i == 0){
            printf("WE HAVE TO SAY GOODBYE\n");
            break;
        }

        int l = strncmp("List" , buffer , 4);
        if (l == 0){
            write (sockfd, buffer, 4);
            while (1){
                char buf2[256];
                bzero(buf2, 256);
                read(sockfd, buf2, 255);
                if (strncmp(buf2, "stop", 4)==0) 
                    break;
                printf("%s\n", buf2);
                //write(sockfd, "ok", 2);
            }

        }
        else if(strncmp("Get" , buffer , 3) == 0){
            bzero(buffer , 255);

            FILE *f;
            int words = 0;

            char c;

            f = fopen("glad.txt" , "r");
            while((c = getc(f)) != EOF)
            {
                fscanf(f , "%s" , buffer);
                if(isspace(c) || c=='\t')
                    words++;
            }

            write(sockfd , &words , sizeof(int));
            rewind(f);

            char ch;
            while(ch!=EOF){
                fscanf(f, "%s", buffer);
                write(sockfd , buffer, 255);
                ch = fgetc(f);
            }
            printf("This file has been succesfully sent.");


        }
    //close(sockfd);
    //return 0;
    }
    close(sockfd);
    return 0;


}